Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.linked
Class NodeImpl

    java.lang.Object
      net.sf.saxon.tree.linked.NodeImpl

All Implemented Interfaces:
  Source, SourceLocator, PullEvent, FingerprintedNode, Item<NodeInfo>, MutableNodeInfo, NodeInfo, ValueRepresentation<NodeInfo>, SiblingCountingNode

Direct Known Subclasses:
  DocumentImpl, ElementImpl

    public abstract class NodeImpl

extends Object
implements MutableNodeInfo, FingerprintedNode, SiblingCountingNode, SourceLocator

A node in the "linked" tree representing any kind of node except a namespace node. Specific node kinds are represented by concrete subclasses.

Author:
  Michael H. Kay

Field Summary
`static char[]` | `NODE_LETTER` Chararacteristic letters to identify each type of node, indexed using the node type values.

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Constructor Summary
`NodeImpl()`

Method Summary
`void` | `addAttribute(NodeName name, SimpleType attType, CharSequence value, int properties)` Add an attribute to this element node.
`void` | `addNamespace(NamespaceBinding nscode, boolean inherit)` Add a namespace binding (that is, a namespace node) to this element.
`Value` | `atomize()` Get the typed value.
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` | `delete()` Delete this node (that is, detach it from its parent)
`boolean` | `equals(Object other)` The equals() method compares nodes for identity.
`void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node
`String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` | `getAttributeValue(String uri, String localName)` Find the value of a given attribute of this node.
`String` | `getBaseURI()` Get the base URI for the node.
`int` | `getColumnNumber()` Get the column number of the node.
`Configuration` | `getConfiguration()` Get the configuration
`NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`String` | `getDisplayName()` Get the display name of this node.
`long` | `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` | `getDocumentRoot()` Get the root (document) node
`int` | `getFingerprint()` Get the fingerprint of the node.
`NodeInfo` | `getFirstChild()` Get first child - default implementation used for leaf nodes
`NodeInfo` | `getLastChild()` Get last child - default implementation used for leaf nodes
`int` | `getLineNumber()` Get the line number of the node within its source document entity
`String` | `getLocalPart()` Get the local name of this node.
`int` | `getNameCode()` Get the nameCode of the node.
`NamePool` | `getNamePool()` Get the NamePool
`NodeImpl` | `getNextInDocument(NodeImpl anchor)` Get the next node in document order
`NodeInfo` | `getNextSibling()` Get next sibling node
`NodeInfo` | `getParent()` Find the parent node of this node.
`DocumentImpl` | `getPhysicalRoot()` Get the physical root of the tree.
`String` | `getPrefix()` Get the prefix part of the name of this node.
`NodeImpl` | `getPreviousInDocument()` Get the previous node in document order
`NodeInfo` | `getPreviousSibling()` Get the previous sibling of the node
`String` | `getPublicId()` Get the public identifier of the document entity containing this node.
`protected net.sf.saxon.tree.linked.ParentNodeImpl` | `getRawParent()` Get the raw value of the parent pointer.
`NodeInfo` | `getRoot()` Get the root node
`SchemaType` | `getSchemaType()` Get the type annotation
`protected long` | `getSequenceNumber()` Get the node sequence number (in document order).
`int` | `getSiblingPosition()` Get the index position of this node among its siblings (starting from 0)
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`String` | `getSystemId()` Get the system ID for the node.
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any
`SequenceIterator<? extends AtomicValue>` | `getTypedValue()` Get the typed value of this node.
`String` | `getURI()` Get the URI part of the name of this node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`void` | `insertChildren(NodeInfo[] source, boolean atStart, boolean inherit)` Insert a sequence of nodes as children of this node.
`void` | `insertSiblings(NodeInfo[] source, boolean before, boolean inherit)` Insert copies of a sequence of nodes as siblings of this node.
`boolean` | `isDeleted()` Test whether this MutableNodeInfo object represents a node that has been deleted.
`boolean` | `isId()` Determine whether this node has the is-id property
`boolean` | `isIdref()` Determine whether this node has the is-idref property
`boolean` | `isNilled()` Determine whether the node has the is-nilled property
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an enumeration over the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an enumeration over the nodes reached by the given axis from this node
`Builder` | `newBuilder()` Get a Builder suitable for building nodes that can be attached to this document.
`void` | `removeAttribute(NodeInfo attribute)` Remove an attribute from this element node
`void` | `removeTypeAnnotation()` Remove type information from this node (and its ancestors, recursively).
`void` | `rename(NodeName newNameCode)` Rename this node
`void` | `replace(NodeInfo[] replacement, boolean inherit)` Replace this node with a given sequence of nodes.
`protected void` | `setRawParent(net.sf.saxon.tree.linked.ParentNodeImpl parent)` Set the raw parent pointer
`protected void` | `setSiblingPosition(int index)` Set the index position.
`void` | `setSystemId(String uri)` Set the system ID of this node.
`void` | `setTypeAnnotation(int typeCode)` Set the type annotation on a node.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.MutableNodeInfo
`replaceStringValue`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`copy, getNodeKind, getStringValue, hashCode`

Field Detail

### NODE_LETTER

    public static final char[] NODE_LETTER

  Chararacteristic letters to identify each type of node, indexed using the node type values. These are used as the initial letter of the result of generate-id()

Constructor Detail

### NodeImpl

    public NodeImpl()

Method Detail

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation<NodeInfo>`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    the type annotation, as the integer name code of the type name

### getSchemaType

    public SchemaType getSchemaType()

  Get the type annotation

  Specified by:
    `getSchemaType` in interface `NodeInfo`
  Returns:
    the type annotation of the base node

### getColumnNumber

    public int getColumnNumber()

  Get the column number of the node. The default implementation returns -1, meaning unknown

  Specified by:
    `getColumnNumber` in interface `SourceLocator`
  Specified by:
    `getColumnNumber` in interface `NodeInfo`
  Returns:
    the column number of the node in its original source document; or -1 if not available

### getPublicId

    public String getPublicId()

  Get the public identifier of the document entity containing this node. The default implementation returns null, meaning unknown

  Specified by:
    `getPublicId` in interface `SourceLocator`

### getDocumentNumber

    public long getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Returns:
    the document number of the document containing this node

### getSiblingPosition

    public final int getSiblingPosition()

  Get the index position of this node among its siblings (starting from 0)

  Specified by:
    `getSiblingPosition` in interface `SiblingCountingNode`
  Returns:
    0 for the first child, 1 for the second child, etc. Returns -1 for a node that has been deleted.

### setSiblingPosition

    protected final void setSiblingPosition(int index)

  Set the index position. For internal use only

  Parameters:
    `index` - the position of the node among its siblings, counting from zero.

### getTypedValue

    public SequenceIterator<? extends AtomicValue> getTypedValue()
                                                          throws XPathException

  Get the typed value of this node. If there is no type annotation, we return the string value, as an instance of xs:untypedAtomic

  Specified by:
    `getTypedValue` in interface `Item<NodeInfo>`
  Returns:
    an iterator over the items in the typed value of the node or atomic value. The items returned by this iterator will always be atomic values.
  Throws:
    `XPathException` - where no typed value is available, for example in the case of an element with complex content

### atomize

    public Value atomize()
                  throws XPathException

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `NodeInfo`
  Returns:
    the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
  Throws:
    `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
  Since:
    8.5

### setSystemId

    public void setSystemId(String uri)

  Set the system ID of this node. This method is provided so that a NodeInfo implements the javax.xml.transform.Source interface, allowing a node to be used directly as the Source of a transformation

  Specified by:
    `setSystemId` in interface `Source`

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### equals

    public boolean equals(Object other)

  The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().

  Specified by:
    `equals` in interface `NodeInfo`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
  Since:
    8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

### getNameCode

    public int getNameCode()

  Get the nameCode of the node. This is used to locate the name in the NamePool

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  See Also:
    `allocate`, `getFingerprint`

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the node. This is used to compare whether two nodes have equivalent names. Return -1 for a node with no name.

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node

  Specified by:
    `generateId` in interface `NodeInfo`
  Parameters:
    `buffer` - a buffer which will be updated to hold a string that uniquely identifies this node, across all documents.

### getSystemId

    public String getSystemId()

  Get the system ID for the node. Default implementation for child nodes.

  Specified by:
    `getSystemId` in interface `Source`
  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

### getBaseURI

    public String getBaseURI()

  Get the base URI for the node. Default implementation for child nodes.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

### getSequenceNumber

    protected long getSequenceNumber()

  Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and roots) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position. This is the default implementation for child nodes. For nodes added by XQuery Update, the sequence number is -1L

  Returns:
    the sequence number if there is one, or -1L otherwise.

### compareOrder

    public final int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the NamePool

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the namepool

### getPrefix

    public String getPrefix()

  Get the prefix part of the name of this node. This is the name before the ":" if any.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    the prefix part of the name. For an unnamed node, return an empty string.

### getURI

    public String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For the null namespace, return an empty string. For an unnamed node, return the empty string.

### getDisplayName

    public String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getLocalPart

    public String getLocalPart()

  Get the local name of this node.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    The local name of this node. For a node with no name, return "",.

### getLineNumber

    public int getLineNumber()

  Get the line number of the node within its source document entity

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getParent

    public final NodeInfo getParent()

  Find the parent node of this node.

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    The Node object describing the containing element or root node.

### getRawParent

    protected final net.sf.saxon.tree.linked.ParentNodeImpl getRawParent()

  Get the raw value of the parent pointer. This will usually be the same as the parent node in the XDM model, but in the case of a parentless element it will be a pointer to the "imaginary" document node which is not properly part of the tree.

  Returns:
    either the real parent of this node, or the "imaginary" parent present in the tree implementation to provide a root object for the tree

### setRawParent

    protected final void setRawParent(net.sf.saxon.tree.linked.ParentNodeImpl parent)

  Set the raw parent pointer

  Parameters:
    `parent` - the "raw" parent pointer: either the real parent, or a dummy parent added to ensure that the tree is properly rooted.

### getPreviousSibling

    public NodeInfo getPreviousSibling()

  Get the previous sibling of the node

  Returns:
    The previous sibling node. Returns null if the current node is the first child of its parent.

### getNextSibling

    public NodeInfo getNextSibling()

  Get next sibling node

  Returns:
    The next sibling node of the required type. Returns null if the current node is the last child of its parent.

### getFirstChild

    public NodeInfo getFirstChild()

  Get first child - default implementation used for leaf nodes

  Returns:
    null

### getLastChild

    public NodeInfo getLastChild()

  Get last child - default implementation used for leaf nodes

  Returns:
    null

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an enumeration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - The axis to be iterated over
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an enumeration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - The axis to be iterated over
    `nodeTest` - A pattern to be matched by the returned nodes
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getAttributeValue

    public String getAttributeValue(String uri,
                                    String localName)

  Find the value of a given attribute of this node.
  This method is defined on all nodes to meet XSL requirements, but for nodes other than elements it will always return null.

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `uri` - the namespace uri of an attribute
    `localName` - the local name of an attribute
  Returns:
    the value of the attribute, if it exists, otherwise null

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the logical root of the tree. For this tree implementation the root will either be a document node or an element node.

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document. If this node is part of a tree that does not have a document node as its root, returns null.

### getPhysicalRoot

    public DocumentImpl getPhysicalRoot()

  Get the physical root of the tree. This may be an imaginary document node: this method should be used only when control information held at the physical root is required

  Returns:
    the document node, which may be imaginary. In the case of a node that has been detached from the tree by means of a delete() operation, this method returns null.

### getNextInDocument

    public NodeImpl getNextInDocument(NodeImpl anchor)

  Get the next node in document order

  Parameters:
    `anchor` - the scan stops when it reaches a node that is not a descendant of the specified anchor node
  Returns:
    the next node in the document, or null if there is no such node

### getPreviousInDocument

    public NodeImpl getPreviousInDocument()

  Get the previous node in document order

  Returns:
    the previous node in the document, or null if there is no such node

### getDeclaredNamespaces

    public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    `true` if the node has any children, `false` if the node has no children.

### isId

    public boolean isId()

  Determine whether this node has the is-id property

  Specified by:
    `isId` in interface `NodeInfo`
  Returns:
    true if the node is an ID

### isIdref

    public boolean isIdref()

  Determine whether this node has the is-idref property

  Specified by:
    `isIdref` in interface `NodeInfo`
  Returns:
    true if the node is an IDREF or IDREFS element or attribute

### isNilled

    public boolean isNilled()

  Determine whether the node has the is-nilled property

  Specified by:
    `isNilled` in interface `NodeInfo`
  Returns:
    true if the node has the is-nilled property

### setTypeAnnotation

    public void setTypeAnnotation(int typeCode)

  Set the type annotation on a node. This must only be called when the caller has verified (by validation) that the node is a valid instance of the specified type. The call is ignored if the node is not an element or attribute node.

  Specified by:
    `setTypeAnnotation` in interface `MutableNodeInfo`
  Parameters:
    `typeCode` - the type annotation (possibly including high bits set to indicate the isID, isIDREF, and isNilled properties)

### delete

    public void delete()

  Delete this node (that is, detach it from its parent)

  Specified by:
    `delete` in interface `MutableNodeInfo`

### isDeleted

    public boolean isDeleted()

  Test whether this MutableNodeInfo object represents a node that has been deleted. Generally, such a node is unusable, and any attempt to use it will result in an exception being thrown

  Specified by:
    `isDeleted` in interface `MutableNodeInfo`
  Returns:
    true if this node has been deleted

### removeAttribute

    public void removeAttribute(NodeInfo attribute)

  Remove an attribute from this element node

  If this node is not an element, or if the specified node is not an attribute of this element, this method takes no action.

  The attribute object itself becomes unusable; any attempt to use this attribute object, or any other object representing the same node, is likely to result in an exception.

  Specified by:
    `removeAttribute` in interface `MutableNodeInfo`
  Parameters:
    `attribute` - the attribute node to be removed

### addAttribute

    public void addAttribute(NodeName name,
                             SimpleType attType,
                             CharSequence value,
                             int properties)

  Add an attribute to this element node.

  If this node is not an element, or if the supplied node is not an attribute, the method takes no action. If the element already has an attribute with this name, the method throws an exception.

  This method does not perform any namespace fixup. It is the caller's responsibility to ensure that any namespace prefix used in the name of the attribute (or in its value if it has a namespace-sensitive type) is declared on this element.

  Specified by:
    `addAttribute` in interface `MutableNodeInfo`
  Parameters:
    `name` - the name of the new attribute
    `attType` - the type annotation of the new attribute
    `value` - the string value of the new attribute
    `properties` - properties including IS_ID and IS_IDREF properties
  Throws:
    `IllegalStateException` - if the element already has an attribute with the given name.

### rename

    public void rename(NodeName newNameCode)

  Rename this node

  Specified by:
    `rename` in interface `MutableNodeInfo`
  Parameters:
    `newNameCode` - the NamePool code of the new name

### addNamespace

    public void addNamespace(NamespaceBinding nscode,
                             boolean inherit)

  Description copied from interface: `MutableNodeInfo`
  Add a namespace binding (that is, a namespace node) to this element. This call has no effect if applied to a node other than an element.

  Specified by:
    `addNamespace` in interface `MutableNodeInfo`
  Parameters:
    `nscode` - The namespace code representing the (prefix, uri) pair of the namespace binding to be added. If the target element already has a namespace binding with this (prefix, uri) pair, the call has no effect. If the target element currently has a namespace binding with this prefix and a different URI, an exception is raised.
    `inherit` - If true, the new namespace binding will be inherited by any children of the target element that do not already have a namespace binding for the specified prefix, recursively. If false, the new namespace binding will not be inherited.

### replace

    public void replace(NodeInfo[] replacement,
                        boolean inherit)

  Replace this node with a given sequence of nodes. This node is effectively deleted, and the replacement nodes are attached to the parent of this node in its place.

  The supplied nodes will become children of this node's parent. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

  Specified by:
    `replace` in interface `MutableNodeInfo`
  Parameters:
    `replacement` - the replacement nodes. If this node is an attribute, the replacements must also be attributes; if this node is not an attribute, the replacements must not be attributes. source the nodes to be inserted. The implementation determines what implementation classes of node it will accept; this implementation will accept attribute, text, comment, and processing instruction nodes belonging to any implementation, but elements must be instances of `ElementImpl`. The supplied nodes will be modified in situ, for example to change their parent property and to add namespace bindings, if they are instances of `ElementImpl`; otherwise they will be copied. If the nodes are copied, then on return the supplied source array will contain the copy rather than the original.
    `inherit` - true if the replacement nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
  Throws:
    `IllegalArgumentException` - if any of the replacement nodes is of the wrong kind. When replacing a child node, the replacement nodes must all be elements, text, comment, or PI nodes; when replacing an attribute, the replacement nodes must all be attributes.
    `IllegalStateException` - if this node is deleted or if it has no parent node. or if two replacement attributes have the same name.

### insertChildren

    public void insertChildren(NodeInfo[] source,
                               boolean atStart,
                               boolean inherit)

  Insert a sequence of nodes as children of this node.

  This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

  The supplied nodes will form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

  Specified by:
    `insertChildren` in interface `MutableNodeInfo`
  Parameters:
    `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; all implementations must accept nodes constructed using the Builder supplied by the `newBuilder()` method on this object. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, but this depends on the implementation. The argument array may be modified as a result of the call.
    `atStart` - true if the new nodes are to be inserted before existing children; false if they are to be inserted after existing children
    `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
  Throws:
    `IllegalArgumentException` - if the supplied nodes use a node implementation that this implementation does not accept.

### insertSiblings

    public void insertSiblings(NodeInfo[] source,
                               boolean before,
                               boolean inherit)

  Insert copies of a sequence of nodes as siblings of this node.

  This method takes no action unless the target node is an element, text node, comment, or processing instruction, and one that has a parent node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

  The supplied nodes must use the same data model implementation as the tree into which they will be inserted.

  Specified by:
    `insertSiblings` in interface `MutableNodeInfo`
  Parameters:
    `source` - the nodes to be inserted
    `before` - true if the new nodes are to be inserted before the target node; false if they are
    `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared

### removeTypeAnnotation

    public void removeTypeAnnotation()

  Remove type information from this node (and its ancestors, recursively). This method implements the upd:removeType() primitive defined in the XQuery Update specification

  Specified by:
    `removeTypeAnnotation` in interface `MutableNodeInfo`

### newBuilder

    public Builder newBuilder()

  Get a Builder suitable for building nodes that can be attached to this document.

  Specified by:
    `newBuilder` in interface `MutableNodeInfo`
  Returns:
    a new Builder that constructs nodes using the same object model implementation as this one, suitable for attachment to this tree

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.